#ifndef CHARACTER_COLLISION_CALLBACK_H_INCLUDED
#define CHARACTER_COLLISION_CALLBACK_H_INCLUDED

#include <btBulletDynamicsCommon.h>

/**
 * This class provides a means of transportation when the player or an enemy
 * collides with another physics body. The resulting collision object is written
 * to an instance of this class and may be accessed from the class
 * btCollisionWorld::ClosestConvexResultCallback.
 */
class CharacterCollisionCallback : public btCollisionWorld::ClosestConvexResultCallback {
private:
	btCollisionObject *me;
public:
	/**
	 * constructs an collision callback
	 */
	CharacterCollisionCallback(btCollisionObject *me, const btVector3 &from,
		const btVector3 &to)
		: btCollisionWorld::ClosestConvexResultCallback(from, to), me(me) {
	}
	virtual btScalar addSingleResult(btCollisionWorld::LocalConvexResult &result, bool normal) {
		if (result.m_hitCollisionObject == me) return 1.0f;
		return btCollisionWorld::ClosestConvexResultCallback::addSingleResult(
			result, normal);
	}
};

#endif