#ifndef EXPLOSIVE_H_INCLUDED
#define EXPLOSIVE_H_INCLUDED

#include "Horde3D.h"
#include <btBulletDynamicsCommon.h>

#include "Physics.h"
#include "Game.h"
#include "Vec3.h"
#include "IShootable.h"

/**
 * This class provides a explosive model in respect to graphics and physics.
 * Please note that the current implementation shows up only as a barrel of gasoline.
 */
class Explosive : public IShootable {
private:
	btCylinderShape* _cylinder;
	btDefaultMotionState* _groundMotionState;
	H3DNode _model, _emitter, _parent;
	float _cylinderHeight, _cylinderRadius, _levelBelowCylinder, _scale;
	bool _doExplode;
public:
	Explosive(Game* game, H3DNode parent, Physics* physics, const int id, H3DRes modelRes, const Vec3 position, const Vec3 rotation, const float scale);
	~Explosive();
	void update(const float timeStep);
	Vec3 getPosition();
	bool castRayAndCorrectPosition(Vec3& calculatedCurrentPosition, Vec3& collisionPoint);
private:
	void setPosition(Vec3 newPosition);
	void hit();
};

#endif